|  | Home · All Classes · Modules

# QWriteLocker Class Reference
[QtCore module]

The QWriteLocker class is a convenience class that simplifies locking and unlocking read-write locks for write access. More...

### Methods

- __init__ (self, QReadWriteLock areadWriteLock)
- QReadWriteLock readWriteLock (self)
- relock (self)
- unlock (self)

### Special Methods

- object __enter__ (self)
- __exit__ (self, object type, object value, object traceback)

## Detailed Description

The QWriteLocker class is a convenience class that simplifies locking and unlocking read-write locks for write access.

The purpose of QWriteLocker (and QReadLocker is to simplify QReadWriteLock locking and unlocking. Locking and unlocking statements or in exception handling code is error-prone and difficult to debug. QWriteLocker can be used in such situations to ensure that the state of the lock is always well-defined.

Here's an example that uses QWriteLocker to lock and unlock a read-write lock for writing:

     QReadWriteLock lock;

     void writeData(const QByteArray &data)
     {
         QWriteLocker locker(&lock);
         ...
     }

It is equivalent to the following code:

     QReadWriteLock lock;

     void writeData(const QByteArray &data)
     {
         lock.lockForWrite();
         ...
         lock.unlock();
     }

The QMutexLocker documentation shows examples where the use of a locker object greatly simplifies programming.

## Method Documentation

### QWriteLocker.__init__ (self, QReadWriteLock areadWriteLock)

Constructs a QWriteLocker and locks lock for writing. The lock will be unlocked when the QWriteLocker is destroyed. If `lock` is zero, QWriteLocker does nothing.

See also QReadWriteLock.lockForWrite().

### QReadWriteLock QWriteLocker.readWriteLock (self)

Returns a pointer to the read-write lock that was passed to the constructor.

### QWriteLocker.relock (self)

Relocks an unlocked lock.

See also unlock().

### QWriteLocker.unlock (self)

Unlocks the lock associated with this locker.

See also QReadWriteLock.unlock().

### object QWriteLocker.__enter__ (self)

### QWriteLocker.__exit__ (self, object type, object value, object traceback)